      subroutine breakit(i,j,k,nodetarg,idims,jdims,kdims,
     .                   idiv,jdiv,kdiv,maxsplit)
      parameter(itarg=25,nodemax=4100000)
      parameter(lap=2)
      dimension idims(maxsplit),jdims(maxsplit),kdims(maxsplit)
      real it2

      irn(n,m) = max(1,nint(float(n)/float(m)))

      nmaxtry=nodemax
      nmaxinc=nmaxtry/4
      incdir=-1
      A2 = log(2.)
1     continue
      it2 = float(i) / ((float(i*j*k) / float(nodetarg))**(1./3.))
      ipower = max(0,nint(log(it2)/A2))
      if (2**ipower.gt.i) ipower=log(float(i))/A2

3     idiv = 2**ipower
      newi = i + (idiv-1)*lap
      if (newi/idiv.gt.itarg) then
	ipower=ipower+1
	goto 3
      end if

      idiv = min(idiv,i)
      call parcel(newi,idiv,idims,imax)
      jkmax = nmaxtry / imax
      if (j.lt.k) then
	jtarg = sqrt(float(jkmax))
	call cktarg(jtarg,lap)
	jdiv  = irn(j,jtarg)
        newj = j + (jdiv-1)*lap
	jdiv  = irn(newj,jtarg)
        newj = j + (jdiv-1)*lap
	call parcel(newj,jdiv,jdims,jmax)
	ktarg = float(nmaxtry) / float(imax*jmax)
	call cktarg(ktarg,lap)
        kdiv = k/ktarg
20      newk = k + (kdiv-1)*lap
        if (ktarg*kdiv.lt.newk) then
	  kdiv=kdiv+1
	  goto 20
        end if
	call parcel(newk,kdiv,kdims,kmax)
      else
	ktarg = sqrt(float(jkmax))
	call cktarg(ktarg,lap)
	kdiv  = irn(k,ktarg)
        newk = k + (kdiv-1)*lap
	kdiv  = irn(newk,ktarg)
        newk = k + (kdiv-1)*lap
	call parcel(newk,kdiv,kdims,kmax)
	jtarg = float(nmaxtry) / float(imax*kmax)
	call cktarg(jtarg,lap)
        jdiv = j/jtarg
30      newj = j + (jdiv-1)*lap
        if (jtarg*jdiv.lt.newj) then
	  jdiv=jdiv+1
	  goto 30
        end if
	call parcel(newj,jdiv,jdims,jmax)
      end if
      ntotal = 0
      nnodes = idiv*jdiv*kdiv
      if (nnodes.lt.nodetarg) then
	nmaxinc = max(1,min(nmaxinc,nmaxtry/2))
	if (incdir.lt.0) then
	  nmaxtry = nmaxtry - nmaxinc
	  if (nmaxinc.eq.1 .and. nmaxtry.eq.0) then
	    write(*,*) 'this is as close as we get!  Too many nodes.'
	    goto 2
          end if
        else
	  if (nmaxinc.eq.1) then
	    write(*,*) 'this is as close as we get!'
            write(*,*) 'i,j,kdiv = ',idiv,jdiv,kdiv
            write(*,*) 'nnodes = ',nnodes,' nodetarg = ',nodetarg
	    goto 2
          end if
	  nmaxinc = max(nmaxinc/3,1)
	  incdir = -1
	  nmaxtry = nmaxtry - nmaxinc
	end if
	goto 1
      else if (nnodes.gt.nodetarg) then
	if (nmaxtry.ge.nodemax) then
	  write(*,*) 'too many points for ',nodetarg,' nodes!  Stopping'
	  stop
	end if
	if (incdir.gt.0) then
	  nmaxtry = nmaxtry + nmaxinc
        else
	  nmaxinc = max(nmaxinc/3,1)
	  incdir = 1
	  nmaxtry = nmaxtry + nmaxinc
	end if
	goto 1
      end if
2     continue
	  
      return
      end

      subroutine parcel(i,nd,ijk,irmax)
      dimension ijk(nd)
      n = 0
      ir = i
      irmax = 0
10    continue
      if (n .eq. nd-1) goto 20
      ip = ir / (nd-n)
      n = n+1
      ijk(n) = ip
      irmax = max(irmax,ip)
      ir = ir - ip
      goto 10
20    continue
      ijk(nd) = ir
      irmax = max(irmax,ir)
      return
      end

      subroutine cktarg(n,lap)
      if (n.le.lap) then
	write(*,*) "target < lap can't be done!"
	write(*,*) 'Increasing to lap+1 = ',lap+1
	n = lap+1
      end if
      return
      end
