c iprec indicates single(4) or double(8) precision.  Array and
c variable dimensions must still be hand modified.
      parameter(iprec=4)
c The size of the full grid
      parameter(jdhost=200,kdhost=200)
c The minimum and maximum number of nodes which will be used
c For a given grid size, if nodemin is too small, the message 
c "load: Not enough memory" will be seen at runtime.  Either
c nodemin must be raised, or memory usage must be reduced. 
      parameter(nodemin=4,nodemax=16)
c The maximum number of sub-zones in any one direction (<= nodemax)
      parameter(maxsplit=8)
c other maximum dimensions
      parameter(NONE=max(jdhost,kdhost))
      parameter(NTHREE=
     .         (jdhost+nodemin) * (kdhost+nodemin) / nodemin  )
c Maximum number of iterations, print interval, residual to stop at.
c (use a very small maxit (even 1) for I/O testing - convergence will
c require thousands of steps.)
      parameter(maxit=500,iprint=1,target=2.0E-8)
c Number of message ids to be used simultaneously at each node
c   during asynchronous writes.
      parameter(nids=5)
